#include <iostream>
#include <fstream>
#include <string>

#include "szekin.h"
#include "szekout.h"


using namespace std;

/*
A rekord formátuma
[név] [adatokszáma] [1. adat] ... [n. adat]

ha a több input fájlban azonos névvel rendelkező rekord van, akkor azok közül a nagyobb értékkel rendelkező rekord fog bekerülni a kimenetbe
*/
int main()
{
	SzekIn in1("in1.txt");
	SzekIn in2("in2.txt");
	SzekOut out("out.txt");

	// Nagy Krisztián oldalán megtaláljátok a táblás anyagot ahol az összefuttatások algoritmusai fent vannak
	// http://valdar.web.elte.hu/downloads/osszefuttato_felsorolo.pdf
	//
	// 3 algoritmus van:
	//   * únió - itt minden esetben kiírjuk a beolvasott rekordot, csak ha mindkettőben benne van akkor abban az esetben még valamilyen érték szerint elágazunk
	//   * szimmetrikus differencia - ebben az esetben a középső ág ahol az únióban az összehasonlítás történt, nem csinálunk semmit csak léptetjük az inputokat
	//   * különbség - ebben az esetben meg csak az első ágban írunk ki az outputra, mivel a különbség az ami az elsőben benne van, de a 2.ban nincs
	//
	// A 3 algoritmus kb teljesen ugyanaz, csak más esetekben írunk az outputra
	// A lényeg az, hogy mindig azzal lépünk ami hátrébb van (azonosító szerint, pl.: ha az első fájl 41-en áll a 2. meg 45-n, akkor az 1-t léptetjük)
	//	 ha pedig mindkettő ugyanazon áll akkor algoritmusonként mást teszünk



	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////ÚNIÓ ////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	while(in1.getStatus() == NORM || in2.getStatus() == NORM)
	{
		cout << in1.current() << endl << in2.current() << endl;
		cout << "------------------" << endl;

		///1. ág - ez az ág akkor fut le amikor az elsőt kell kiiratni az outputra
		if(
			in2.getStatus() == ABNORM || // ha már csak az első maradt(2. fájl már abnorm), akkor csak ki kell írni a rekordokat
			(in1.getStatus() == NORM && in1.current() < in2.current()) // ha mindkettő norm és az második fájl tart előrébb
		  )
		{
			cout << "1. ag nyert" << endl;
			out.write(in1.current());// akkor az első fájlból a rekordot kiírjuk szimplán
			in1.next(); // és léptetjük az inputot
		}
		// középső ág - ez az ág akkor fut le amikor a mind a két fájl azonos azonosítójú rekordon áll
		else if(in1.getStatus() == NORM && in2.getStatus() == NORM &&  //ha mindkettő fájl még megy
				in1.current() == in2.current()) // és azonos rekord azonosítóról van szó
		{
			cout << "kozepso ag nyert" << endl;
			if(in1.current().getErtek() > in2.current().getErtek())//akkor a nagyobb értékkel rendelkezőt írjuk ki
			{
		 		out.write(in1.current());
			}
			else
			{
				out.write(in2.current());
			}
			in1.next();// és léptetjük mind a két inputot
			in2.next();
		}
		// 2. ág - ebben az esetben a 2. fájlból írjuk ki a rekordot
		else //a stukiban lévő ifek mindig teljesek, szóval itt esetünkben elég else-t írni
		{
			cout << "2. ag nyert" << endl;
			out.write(in2.current());
			in2.next();
		}
		cout << "=================" << endl;
	}




	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////SZIMMETRIKUS DIFFERENCIA ///////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	/*while(in1.getStatus() == NORM || in2.getStatus() == NORM)
	{
		cout << in1.current() << endl << in2.current() << endl;
		cout << "------------------" << endl;
		if(
			in2.getStatus() == ABNORM || // ha már csak az első maradt(2. fájl már abnorm), akkor csak ki kell írni a rekordokat
			(in1.getStatus() == NORM && in1.current() < in2.current()) // ha mindkettő norm és az második fájl tart előrébb
		  )
		{
			cout << "1. ag nyert" << endl;
			out.write(in1.current());// akkor az első fájlból a rekordot kiírjuk szimplán
			in1.next(); // és léptetjük az inputot
		}
		else if(in1.getStatus() == NORM && in2.getStatus() == NORM &&  //ha mindkettő fájl még megy
				in1.current() == in2.current()) // és azonos rekord azonosítóról van szó
		{
			cout << "kozepso ag nyert" << endl;
			//ebben az esetben nem írunk ki semmit, mivel a szimmetrikus differenciában az únió középső része nem kell
			in1.next();// és léptetjük mind a két inputot
			in2.next();
		}
		else //a stukiban lévő ifek mindig teljesek, szóval itt esetünkben elég else-t írni
		{
			cout << "2. ag nyert" << endl;
			out.write(in2.current());
			in2.next();
		}
		cout << "=================" << endl;
	}*/

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////KÜLÖNBSÉG ///////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	/*while(in1.getStatus() == NORM)
	{
		cout << in1.current() << endl << in2.current() << endl;
		cout << "------------------" << endl;
		if(
			in2.getStatus() == ABNORM || // ha már csak az első maradt(2. fájl már abnorm), akkor csak ki kell írni a rekordokat
			(in1.getStatus() == NORM && in1.current() < in2.current()) // ha mindkettő norm és az második fájl tart előrébb
		  )
		{
			cout << "1. ag nyert" << endl;
			out.write(in1.current());// akkor az első fájlból a rekordot kiírjuk szimplán
			in1.next(); // és léptetjük az inputot
		}
		else if(in1.getStatus() == NORM && in2.getStatus() == NORM &&  //ha mindkettő fájl még megy
				in1.current() == in2.current()) // és azonos rekord azonosítóról van szó
		{
			cout << "kozepso ag nyert" << endl;
			//ebben az esetben nem írunk ki semmit, mivel a szimmetrikus differenciában az únió középső része nem kell
			in1.next();// és léptetjük mind a két inputot
			in2.next();
		}
		else //a stukiban lévő ifek mindig teljesek, szóval itt esetünkben elég else-t írni
		{
			cout << "2. ag nyert" << endl;
			//ebben az esetben
			in2.next();
		}
		cout << "=================" << endl;
	}
	*/
}
